//+------------------------------------------------------------------
//|flat trend mt4
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_color1  Gold
#property indicator_color2  Orange
#property indicator_color3  Gray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    FastEMA         = 12;
extern int    SlowEMA         = 26;
extern int    SignalEMA       =  9;
extern int    Price           = PRICE_CLOSE;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double macd[];
double signal[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,trend);
   
       //
       //
       //
       //
       //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
       
       //
       //
       //
       //
       // 

       IndicatorShortName(timeFrameToString(timeFrame)+"  Flat Trend");  
return(0);
}

//
//
//
//
//

int deinit()  { return(0);  }

//
//
//
//
//
 
double emas[][2];  
int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
      double alphaSign = 2.0/(1.0+SignalEMA);
      double alphaFast = 2.0/(1.0+FastEMA);
      double alphaSlow = 2.0/(1.0+SlowEMA);
      for (i = limit, r=Bars-i-1; i>=0 ; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>Bars-2)
         {
            emas[r][0] = price;
            emas[r][1] = price;
            macd[i]    = 0;
            signal[i]  = 0;
            continue;
         }

         //
         //
         //
         //
         //
         
         emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
         emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
         macd[i]    = emas[r][0]-emas[r][1];
         signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
   
         Buffer1[i]=EMPTY_VALUE;
         Buffer2[i]=EMPTY_VALUE;
         Buffer3[i]=EMPTY_VALUE;
         trend[i] = trend[i+1];
   
         if ( macd[i]>signal[i] && macd[i]>0)                                       trend[i]  = 1;   
         if ( macd[i]<signal[i] && macd[i]<0)                                       trend[i]  =-1; 
         if ((macd[i]>signal[i] && macd[i]<0) || (macd[i]<signal[i] && macd[i]>0))  trend[i]  = 0;
         if (trend[i] == 1) Buffer1[i] = 1;
         if (trend[i] ==-1) Buffer2[i] = 1;
         if (trend[i] == 0) Buffer3[i] = 1;
         
       }
    manageAlerts();
    return(0);
    }   

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,6,y); 
            if (trend[i] == 1) Buffer1[i] = 1;
            if (trend[i] ==-1) Buffer2[i] = 1;
            if (trend[i] == 0) Buffer3[i] = 1;
   }
   manageAlerts();    
return(0);
}
 
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"strong up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"strong down");
            if (trend[whichBar] == 0) doAlert(whichBar,"weak");
         }                
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Flat Trend macd ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Flat Trend macd"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
} 
 
   

